    001/*
    002    Licensed to the Apache Software Foundation (ASF) under one
    003    or more contributor license agreements.  See the NOTICE file
    004    distributed with this work for additional information
    005    regarding copyright ownership.  The ASF licenses this file
    006    to you under the Apache License, Version 2.0 (the
    007    "License"); you may not use this file except in compliance
    008    with the License.  You may obtain a copy of the License at
    009
    010       http://www.apache.org/licenses/LICENSE-2.0
    011
    012    Unless required by applicable law or agreed to in writing,
    013    software distributed under the License is distributed on an
    014    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015    KIND, either express or implied.  See the License for the
    016    specific language governing permissions and limitations
    017    under the License.
    018 */
    019package org.apache.wiki.search;
    020
    021import org.apache.wiki.api.core.Context;
    022import org.apache.wiki.api.core.Page;
    023import org.apache.wiki.api.exceptions.ProviderException;
    024import org.apache.wiki.api.providers.WikiProvider;
    025import org.apache.wiki.api.search.SearchResult;
    026
    027import java.io.IOException;
    028import java.util.Collection;
    029
    030/**
    031 *  Interface for the search providers that handle searching the Wiki
    032 *
    033 *  @since 2.2.21.
    034 */
    035public interface SearchProvider extends WikiProvider {
    036
    037    /**
    038     * Delete a page from the search index.
    039     *
    040     * @param page Page to remove from search index.
    041     */
    042    void pageRemoved( Page page );
    043
    044    /**
    045     * Adds a WikiPage for indexing queue. This is called a queue, since this method is expected to return pretty quickly, and indexing to
    046     * be done in a separate thread.
    047     *
    048     *  @param page The WikiPage to be indexed.
    049     */
    050    void reindexPage( Page page );
    051
    052    /**
    053     * Search for pages matching a search query.
    054     *
    055     * @param query query to search for
    056     * @param wikiContext the context within which to run the search
    057     * @return collection of pages that match query
    058     * @throws ProviderException if the search provider failed.
    059     * @throws IOException if for some reason the query could not be executed.
    060     */
    061    Collection< SearchResult > findPages( String query, Context wikiContext ) throws ProviderException, IOException;
    062
    063}